diff -uNr fwbuilder-2.1.8/src/gui/ObjConflictResolutionDialog.cpp fwbuilder-2.1.9/src/gui/ObjConflictResolutionDialog.cpp
--- fwbuilder-2.1.8/src/gui/ObjConflictResolutionDialog.cpp	2004-11-13 08:31:27.000000000 +0100
+++ fwbuilder-2.1.9/src/gui/ObjConflictResolutionDialog.cpp	2007-02-04 04:58:59.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: ObjConflictResolutionDialog.cpp,v 1.18 2004/11/13 07:31:27 vkurland Exp $
+  $Id: ObjConflictResolutionDialog.cpp,v 1.19 2007/02/04 03:58:59 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -43,8 +43,11 @@
 #include <qtextbrowser.h>
 #include <qcheckbox.h>
 #include <qpushbutton.h>
+#include <qmap.h>
 
 #include <iostream>
+#include <sstream>
+#include <iomanip>
 
 using namespace std;
 using namespace libfwbuilder;
@@ -57,7 +60,12 @@
     alwaysNew    =false;
     dlgIcon->setPixmap( QMessageBox::standardIcon( QMessageBox::Warning ) );
 
+    defaultLeftButtonText = tr("Keep current object");
+    defaultRightButtonText = tr("Replace with this object");
+
     if (st->haveGeometry(this)) st->restoreGeometry(this);
+
+    richText = true;
 }
 
 ObjConflictResolutionDialog::~ObjConflictResolutionDialog()
@@ -65,17 +73,30 @@
     saveGeometry();
 }
 
+QString ObjConflictResolutionDialog::makeBold(const QString &str)
+{
+    QString bold   = (richText)?QString("<b>"):"";
+    QString unbold = (richText)?QString("</b>"):"";
+    return QString("%1%2%3").arg(bold).arg(str).arg(unbold);
+}
+
 int ObjConflictResolutionDialog::run(    FWObject *o1,
                                          FWObject *o2)
 {
-    if (alwaysCurrent) return QDialog::Rejected;
-    if (alwaysNew)     return QDialog::Accepted;
+
+    // fill in dialogs even though the user might have
+    // checked checkbox that makes  decision without
+    // them having to click a button. This is so that
+    // classes that inherit from ObjConflictResolutionDialog
+    // can use data collected in this method. Particularly 
+    // CompareObjectsDialog::run needs it
+    
 
     QString leftBtnTxt, rightBtnTxt;
     bool    leftCB,  rightCB, leftBtn, rightBtn;
 
-    leftBtnTxt  = tr("Keep current object");
-    rightBtnTxt = tr("Replace with this object");
+    leftBtnTxt  = defaultLeftButtonText;
+    rightBtnTxt = defaultRightButtonText;
     leftCB=rightCB=leftBtn=rightBtn=true;
 
     QString p1, p2;
@@ -93,7 +114,7 @@
          * here either. It is unclear how to solve this problem
          * correctly. Defer to the user. */
 
-        p1=tr("Object <b>'%1'</b> has been deleted").arg(o1->getName().c_str());
+        p1=tr("Object '%1' has been deleted").arg(makeBold(o1->getName().c_str()));
         rightBtnTxt = tr("Delete");
         leftCB  = rightCB = leftBtn = false;
     } else
@@ -117,7 +138,7 @@
 
         return QDialog::Rejected;
 
-        p2=tr("Object <b>'%1'</b> has been deleted").arg(o2->getName().c_str());
+        p2=tr("Object '%1' has been deleted").arg(makeBold(o2->getName().c_str()));
         leftBtnTxt = tr("Delete");
         leftCB  = rightCB = rightBtn = false;
     } else
@@ -141,17 +162,32 @@
     QString f1= FWObjectDatabase::cast(o1->getRoot())->getFileName().c_str();
     QString f2= FWObjectDatabase::cast(o2->getRoot())->getFileName().c_str();
 
-    if (f1.isEmpty()) f1=tr("Object <b>'%1'</b> in the objects tree")
-                          .arg(o1->getName().c_str());
-    else f1=tr("Object <b>'%1'</b> in file %2").arg(o1->getName().c_str()).arg(f1);
+    current_filename = f1;
+    new_filename = f2;
+
+    current_objname = o1->getName().c_str();
+    new_objname = o2->getName().c_str();
+
+    current_properties = p1;
+    new_properties = p2;
+
+
+    if (f1.isEmpty())
+        f1=tr("Object '%1' in the objects tree").arg(makeBold(o1->getName().c_str()));
+    else
+        f1=tr("Object '%1' in file %2").arg(makeBold(o1->getName().c_str())).arg(f1);
+
+    f2=tr("Object '%1' in file %2").arg(makeBold(o2->getName().c_str())).arg(f2);
 
-    f2=tr("Object <b>'%1'</b> in file %2").arg(o2->getName().c_str()).arg(f2);
 
     currentObjLbl->setText(f1);
     newObjLbl->setText(f2);
     
     currentObj->clear();
+    currentObj->setTextFormat(Qt::RichText);
+
     newObj->clear();
+    newObj->setTextFormat(Qt::RichText);
 
     QString s;
     s="<a name=\"top\">\n";
@@ -172,6 +208,10 @@
     newObj->append( s );
     newObj->scrollToAnchor("top");
 
+
+    if (alwaysCurrent) return QDialog::Rejected;
+    if (alwaysNew)     return QDialog::Accepted;
+
     return QDialog::exec();
 }
 
@@ -237,3 +277,225 @@
 
     QDialog::reject();
 }
+
+// ################################################################
+
+CompareObjectsDialog::CompareObjectsDialog(QWidget *p) :
+    ObjConflictResolutionDialog(p)
+{
+    richText = false;
+    num_conflicts = 0;
+    column_width[0] = 30;
+    column_width[1] = 30;
+    column_width[2] = 30;
+    column_width[3] = 30;
+
+    currentAll->hide();
+    useCurrentObj->hide();
+
+    defaultLeftButtonText = "";
+    defaultRightButtonText = tr("Next");
+
+    dialogHeading->setText( tr("The following two objects have the same internal ID but different attributes:") );
+    newAll->setText( tr("Skip the rest but build report") );
+
+    clearReport();
+
+    // Note : these keys match strings generated by
+    // FWObjectPropertyFactory::getObjectPropertiesDetailed
+    // That is, getObjectPropertiesDetailed generates text like this:
+    //
+    //  Library: TestLibrary
+    //  Object Id: id3F3D04676
+    //  Object Type: Firewall
+    //  Object Name: guardian
+    //
+    // Keys in report_attributes must match strings before ':' exactly
+
+    report_attributes.push_back("Name");
+    report_attributes.push_back("Library");
+    report_attributes.push_back("Object Id");
+    report_attributes.push_back("Object Type");
+    report_attributes.push_back("Object Name");
+    report_attributes.push_back("Path");
+
+}
+
+void CompareObjectsDialog::writeColumn(ostringstream &sstr,
+                                       int column_num,
+                                       const QString &txt)
+{
+    int col_width = column_width[column_num];
+
+    sstr << txt.latin1() << setw(col_width-txt.length()) << setfill(' ') << ' ';
+}
+
+int CompareObjectsDialog::run(FWObject *o1,FWObject *o2)
+{
+    ostringstream str;
+
+    int res = ObjConflictResolutionDialog::run(o1,o2);
+
+    if (fwbdebug)
+        qDebug(QString("left side: %1 paragraphs, %2 lines in paragraph 0").
+               arg(currentObj->paragraphs()).arg(currentObj->linesOfParagraph(0)));
+
+
+/*
+    currentObj->setTextFormat(Qt::PlainText);
+    QString l_text = currentObj->text(0);
+    // QTextEdit returns whole paragraph as one line
+    // Since we enforce PlainText, all html formatting
+    // is lost and individual lines are glued together
+    // with some character that prints as '?'
+    // Could be chr(0) ?
+
+    if (fwbdebug) qDebug("%s",l_text.ascii());
+
+    newObj->setTextFormat(Qt::PlainText);
+    QString r_text = newObj->text(0);
+
+    if (fwbdebug) qDebug("%s",r_text.ascii());
+
+    str << l_text << endl;
+    str << r_text << endl;
+    str << endl;
+*/
+
+    num_conflicts++;
+
+    QString prop1 = FWObjectPropertiesFactory::stripHTML(current_properties);
+    QString prop2 = FWObjectPropertiesFactory::stripHTML(new_properties);
+
+
+    QStringList proplist1 = QStringList::split("\n",prop1);
+    QStringList proplist2 = QStringList::split("\n",prop2);
+
+    QMap<QString,QString> propdict1;
+    QMap<QString,QString> propdict2;
+
+    int n = 0;
+    QStringList::Iterator i1 = proplist1.begin();
+    for ( ; i1!=proplist1.end(); ++i1,++n)
+    {
+        ostringstream tstr;
+        tstr << "key_" << n;
+
+        QString k = (*i1).section(':',0,0).stripWhiteSpace();
+        QString v = (*i1).section(':',1).stripWhiteSpace();
+        if (v=="") 
+        {
+            v = k;
+            k = tstr.str().c_str();
+        }
+
+        if (fwbdebug) qDebug(QString("proplist1:    k='%1'  v='%2'").arg(k).arg(v));
+
+        propdict1[k] = v;
+    }
+
+    n = 0;
+    QStringList::Iterator i2 = proplist2.begin();
+    for ( ; i2!=proplist2.end(); ++i2,++n)
+    {
+        ostringstream tstr;
+        tstr << "key_" << n;
+
+        QString k = (*i2).section(':',0,0).stripWhiteSpace();
+        QString v = (*i2).section(':',1).stripWhiteSpace();
+        if (v=="")
+        {
+            v = k;
+            k = tstr.str().c_str();
+        }
+
+        if (fwbdebug) qDebug(QString("proplist2:    k='%1'  v='%2'").arg(k).arg(v));
+
+        propdict2[k] = v;
+    }
+
+    
+    QStringList::Iterator i3 = report_attributes.begin();
+    for ( ; i3!=report_attributes.end(); ++i3)
+    {
+        QString attr = *i3;
+
+        if (fwbdebug) qDebug(QString("report_attributes:    attr=%1  ").arg(attr));
+
+        if (!propdict1.contains(attr) || !propdict2.contains(attr)) continue;
+
+        writeColumn(str, 1, attr);
+        writeColumn(str, 2, propdict1[attr]);
+        writeColumn(str, 3, propdict2[attr]);
+        str << endl;
+
+        propdict1[attr] = "";
+        propdict2[attr] = "";
+    }
+
+    QMap<QString,QString>::Iterator mi1 = propdict1.begin();
+    for ( ; mi1!=propdict1.end(); ++mi1)
+    {
+        QString key = mi1.key();
+        QString val = mi1.data();
+
+        if (fwbdebug) qDebug(QString("propdict1:    key=%1  val=%2").arg(key).arg(val));
+
+        if (val=="") continue;
+
+        if (key.startsWith("key_"))  writeColumn(str, 1, " ");
+        else                         writeColumn(str, 1, key);
+        if (propdict1.contains(key)) writeColumn(str, 2, propdict1[key]);
+        else                         writeColumn(str, 2, " ");
+        if (propdict2.contains(key)) writeColumn(str, 3, propdict2[key]);
+        else                         writeColumn(str, 3, " ");
+        str << endl;
+
+        propdict1[key] = "";
+        propdict2[key] = "";
+    }
+
+    QMap<QString,QString>::Iterator mi2 = propdict2.begin();
+    for ( ; mi2!=propdict2.end(); ++mi2)
+    {
+        QString key = mi2.key();
+        QString val = mi2.data();
+
+        if (fwbdebug) qDebug(QString("propdict2:    key=%1  val=%2").arg(key).arg(val));
+
+        if (val=="") continue;
+
+        if (key.startsWith("key_"))  writeColumn(str, 1, " ");
+        else                         writeColumn(str, 1, key);
+        if (propdict1.contains(key)) writeColumn(str, 2, propdict1[key]);
+        else                         writeColumn(str, 2, " ");
+        if (propdict2.contains(key)) writeColumn(str, 3, propdict2[key]);
+        else                         writeColumn(str, 3, " ");
+        str << endl;
+    }
+
+    str << setw(78) << setfill('-') << '-' << endl;
+    
+    report.push_back( QString(str.str()) );
+
+    return res;
+}
+
+void CompareObjectsDialog::clearReport()
+{
+    report.clear();
+}
+
+list<QString> CompareObjectsDialog::getReport()
+{
+    ostringstream str;
+
+    str << "File 1:  " << current_filename.latin1() << endl;
+    str << "File 2:  " << new_filename.latin1() << endl;
+    str << setw(78) << setfill('-') << '-' << endl;
+
+    report.push_front( QString(str.str()) );
+
+    return report;
+}
+
diff -uNr fwbuilder-2.1.8/src/gui/ObjConflictResolutionDialog.h fwbuilder-2.1.9/src/gui/ObjConflictResolutionDialog.h
--- fwbuilder-2.1.8/src/gui/ObjConflictResolutionDialog.h	2004-06-29 08:59:01.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/ObjConflictResolutionDialog.h	2007-02-04 04:58:59.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: ObjConflictResolutionDialog.h,v 1.7 2004/06/29 06:59:01 vkurland Exp $
+  $Id: ObjConflictResolutionDialog.h,v 1.8 2007/02/04 03:58:59 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -31,6 +31,8 @@
 
 #include "fwbuilder/FWObjectDatabase.h"
 
+#include <sstream>
+
 namespace libfwbuilder {
     class FWObject;
 };
@@ -42,14 +44,29 @@
     bool alwaysCurrent;
     bool alwaysNew;
 
-    void saveGeometry();
-    
+protected:
+
+    QString current_filename;
+    QString new_filename;
+    QString current_objname;
+    QString new_objname;
+    QString current_properties;
+    QString new_properties;
+
+    QString defaultLeftButtonText;
+    QString defaultRightButtonText;
+
+    bool    richText;
+
+    void     saveGeometry();
+    QString  makeBold(const QString &str);
+
 public:
     ObjConflictResolutionDialog(QWidget *parent);
     virtual ~ObjConflictResolutionDialog();
 
-    int run( libfwbuilder::FWObject *o1,
-             libfwbuilder::FWObject *o2);
+    virtual int run( libfwbuilder::FWObject *o1,
+                     libfwbuilder::FWObject *o2);
 
 public slots:
     virtual void closeEvent(QCloseEvent *e);
@@ -76,4 +93,36 @@
 };
 
 
+class CompareObjectsDialog :
+    public libfwbuilder::FWObjectDatabase::ConflictResolutionPredicate,
+    ObjConflictResolutionDialog
+{
+    std::list<QString> report;
+    QStringList        report_attributes;
+    int                num_conflicts;
+    int                column_width[];
+    
+    void writeColumn(std::ostringstream &sstr,
+                     int column_num,
+                     const QString &txt);
+
+
+public:
+    CompareObjectsDialog(QWidget *p);
+    
+    virtual int run( libfwbuilder::FWObject *o1,
+                     libfwbuilder::FWObject *o2);
+
+    void clearReport();
+    std::list<QString> getReport();
+    int  getNumberOfConflicts() { return num_conflicts; }
+
+    
+    virtual bool askUser(libfwbuilder::FWObject *o1,libfwbuilder::FWObject *o2)
+    {
+        run(o1,o2);
+        return QDialog::Accepted;
+    }
+};
+
 #endif
diff -uNr fwbuilder-2.1.8/src/gui/objconflictresolutiondialog_q.ui fwbuilder-2.1.9/src/gui/objconflictresolutiondialog_q.ui
--- fwbuilder-2.1.8/src/gui/objconflictresolutiondialog_q.ui	2004-07-11 08:43:10.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/objconflictresolutiondialog_q.ui	2007-02-04 04:58:59.000000000 +0100
@@ -8,8 +8,8 @@
         <rect>
             <x>0</x>
             <y>0</y>
-            <width>688</width>
-            <height>378</height>
+            <width>850</width>
+            <height>436</height>
         </rect>
     </property>
     <property name="caption">
@@ -40,7 +40,7 @@
         </widget>
         <widget class="QLabel" row="0" column="1">
             <property name="name">
-                <cstring>textLabel1</cstring>
+                <cstring>dialogHeading</cstring>
             </property>
             <property name="sizePolicy">
                 <sizepolicy>
@@ -87,6 +87,14 @@
                         <property name="name">
                             <cstring>groupBox1</cstring>
                         </property>
+                        <property name="sizePolicy">
+                            <sizepolicy>
+                                <hsizetype>5</hsizetype>
+                                <vsizetype>7</vsizetype>
+                                <horstretch>0</horstretch>
+                                <verstretch>0</verstretch>
+                            </sizepolicy>
+                        </property>
                         <property name="title">
                             <string></string>
                         </property>
@@ -160,6 +168,14 @@
                         <property name="name">
                             <cstring>groupBox1_2</cstring>
                         </property>
+                        <property name="sizePolicy">
+                            <sizepolicy>
+                                <hsizetype>5</hsizetype>
+                                <vsizetype>7</vsizetype>
+                                <horstretch>0</horstretch>
+                                <verstretch>0</verstretch>
+                            </sizepolicy>
+                        </property>
                         <property name="title">
                             <string></string>
                         </property>
diff -uNr fwbuilder-2.1.8/src/gui/ObjectManipulator.cpp fwbuilder-2.1.9/src/gui/ObjectManipulator.cpp
--- fwbuilder-2.1.8/src/gui/ObjectManipulator.cpp	2006-10-22 20:20:04.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/ObjectManipulator.cpp	2007-01-10 07:28:51.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: ObjectManipulator.cpp,v 1.159 2006/10/22 18:20:04 vkurland Exp $
+  $Id: ObjectManipulator.cpp,v 1.161 2007/01/10 06:28:51 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -130,7 +130,7 @@
     {
         QListViewItem *itm = otv->itemAt( p );
         if (itm==NULL) return;
-        ObjectTreeViewItem *otvi=dynamic_cast<ObjectTreeViewItem*>(itm);
+        ObjectTreeViewItem *otvi = dynamic_cast<ObjectTreeViewItem*>(itm);
         assert(otvi);
         FWObject *obj=otvi->getFWObject();
         QRect     cr =otv->itemRect(itm);
@@ -147,7 +147,7 @@
     treeHeight   = -1;
     currentObj   = NULL;
     active       = false;
-    currentTreeView=NULL;
+    current_tree_view=NULL;
 
 //    setFocusPolicy( QWidget::StrongFocus  );
 
@@ -782,6 +782,22 @@
     }
 }
 
+void ObjectManipulator::switchingTrees(QWidget* w)
+{
+    ObjectTreeView *new_otv = dynamic_cast<ObjectTreeView*>(w);
+
+    if (fwbdebug)
+        qDebug("ObjectManipulator::switchingTrees  current_otv=%p  new_otv=%p",
+               (void*)(current_tree_view),(void*)(new_otv));
+
+    assert(new_otv);
+
+    if (current_tree_view!=NULL) current_tree_view->becomingHidden();
+    new_otv->becomingVisible();
+    current_tree_view = new_otv;
+
+}
+
 void ObjectManipulator::makeNameUnique(FWObject* parent,FWObject* obj)
 {
     int      suffix=1;
@@ -1822,8 +1838,8 @@
     try
     {
         if (fwbdebug)
-            qDebug("ObjectManipulator::delObj  delete obj %p %s",
-                   obj,obj->getName().c_str());
+            qDebug("ObjectManipulator::delObj  delete obj %p %s openobj=%d",
+                   obj,obj->getName().c_str(),openobj);
 
         FWObject *parent=obj->getParent();
         FWObject *delObjLib = mw->db()->findInIndex( DELETED_LIB );
@@ -1866,7 +1882,7 @@
                 mw->deleteFirewall( *i );
         }
 
-        if (isfw) mw->deleteFirewall(obj);
+        if (isfw && !isDelObj) mw->deleteFirewall(obj);
 
 
 //        removeObjectFromTreeView(obj);
@@ -1901,7 +1917,7 @@
 
         if (openobj)
         {
-            if (isfw)
+            if (isfw && !isDelObj)
             {
                 std::list<Firewall*> fwlist;
                 findAllFirewalls(fwlist);
@@ -2161,8 +2177,15 @@
 
 void ObjectManipulator::showObjectInTree(ObjectTreeViewItem *otvi)
 {
+    if (fwbdebug) qDebug("ObjectManipulator::showObjectInTree");
     if (otvi==NULL) return;
-    widgetStack->raiseWidget( currentTreeView=otvi->getTree() );
+
+    ObjectTreeView* otv = otvi->getTree();
+
+    if (fwbdebug) qDebug("ObjectManipulator::showObjectInTree  current_tree_view=%p  new_otv=%p",current_tree_view,otv);
+
+    widgetStack->raiseWidget( otv );
+
     otvi->getTree()->clearSelection();
     otvi->getTree()->ensureItemVisible( otvi );
     otvi->getTree()->setCurrentItem( otvi );
@@ -2242,7 +2265,7 @@
 
 ObjectTreeView* ObjectManipulator::getCurrentObjectTree()
 {
-    return currentTreeView;
+    return current_tree_view;
 }
 
 void ObjectManipulator::openLib(FWObject *obj)
diff -uNr fwbuilder-2.1.8/src/gui/ObjectManipulator.h fwbuilder-2.1.9/src/gui/ObjectManipulator.h
--- fwbuilder-2.1.8/src/gui/ObjectManipulator.h	2006-10-15 23:43:55.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/ObjectManipulator.h	2007-01-08 03:11:48.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: ObjectManipulator.h,v 1.57 2006/10/15 21:43:55 vkurland Exp $
+  $Id: ObjectManipulator.h,v 1.58 2007/01/08 02:11:48 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -83,7 +83,7 @@
     int cacheHits;
 
     libfwbuilder::FWObject                        *currentObj;
-    ObjectTreeView                                *currentTreeView;
+    ObjectTreeView                                *current_tree_view;
     
     int                                            treeWidth;
     int                                            treeHeight;
@@ -124,6 +124,7 @@
 
 public slots:
      virtual void libChanged(int l);
+     virtual void switchingTrees(QWidget* w);
 
      void selectionChanged();
 
@@ -146,6 +147,7 @@
      
      void contextMenu(QListViewItem *item, const QPoint &pos, int col);
 
+     
      libfwbuilder::FWObject* createObject(const QString &objType,
                                           const QString &objName,
                                           libfwbuilder::FWObject *copyFrom=NULL);
diff -uNr fwbuilder-2.1.8/src/gui/objectmanipulator_q.ui fwbuilder-2.1.9/src/gui/objectmanipulator_q.ui
--- fwbuilder-2.1.8/src/gui/objectmanipulator_q.ui	2006-01-21 21:05:39.000000000 +0100
+++ fwbuilder-2.1.9/src/gui/objectmanipulator_q.ui	2007-01-08 03:11:48.000000000 +0100
@@ -190,6 +190,12 @@
         <receiver>ObjectManipulator_q</receiver>
         <slot>newObject()</slot>
     </connection>
+    <connection>
+        <sender>widgetStack</sender>
+        <signal>aboutToShow(QWidget*)</signal>
+        <receiver>ObjectManipulator_q</receiver>
+        <slot>switchingTrees(QWidget*)</slot>
+    </connection>
 </connections>
 <slots>
     <slot>search( const QString &amp; )</slot>
@@ -199,6 +205,8 @@
     <slot>libChanged(int)</slot>
     <slot>lockObject()</slot>
     <slot>unlockObject()</slot>
+    <slot>switchingTrees(QWidget*)</slot>
+    <slot>newSlot()</slot>
 </slots>
 <pixmapinproject/>
 <layoutdefaults spacing="6" margin="11"/>
diff -uNr fwbuilder-2.1.8/src/gui/ObjectTreeView.cpp fwbuilder-2.1.9/src/gui/ObjectTreeView.cpp
--- fwbuilder-2.1.8/src/gui/ObjectTreeView.cpp	2006-10-22 20:20:04.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/ObjectTreeView.cpp	2007-01-08 04:24:48.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: ObjectTreeView.cpp,v 1.37 2006/10/22 18:20:04 vkurland Exp $
+  $Id: ObjectTreeView.cpp,v 1.39 2007/01/08 03:24:48 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -76,6 +76,24 @@
     expandOrCollapse = false;
     Lockable = false;
     Unlockable = false;
+    visible = false;
+    /*
+     * note about process_mouse_release_event
+     *
+     * we use mouseReleaseEvent event to switch object opened in the
+     * editor panel (i.e. we open new object when mouse button is
+     * released rather than when it is pressed). This allows us to
+     * start drag without switching object in the editor. The problem
+     * is that mouseReleaseEvent is received in this widget after the
+     * d&d ends with a drop somewhere else, which triggers call to
+     * contentsMouseReleaseEvent which switches object in the
+     * editor. This is undesired when the editor shows a group and we
+     * try to drag and drop an object into that group. Flag
+     * process_mouse_release_event is used to suppress object
+     * switching when contentsMouseReleaseEvent is called after
+     * successfull drop.
+     */
+    process_mouse_release_event = true;
 
     connect( this, SIGNAL(currentChanged(QListViewItem*)),
              this, SLOT(currentChanged(QListViewItem*)) );
@@ -251,13 +269,12 @@
  */
 QDragObject* ObjectTreeView::dragObject()
 {
-    if (fwbdebug)
-        qDebug("ObjectTreeView::dragObject");
+    if (fwbdebug) qDebug("ObjectTreeView::dragObject");
 
     QListViewItem *ovi = currentItem();
     ObjectTreeViewItem *otvi=dynamic_cast<ObjectTreeViewItem*>(ovi);
 
-    FWObject *obj = getCurrentObject();
+    FWObject *current_obj = getCurrentObject();
 
 /* can't drag system folders 
 
@@ -271,7 +288,7 @@
     if (FWBTree::isSystem(obj)) return NULL;
 */
     QString icn =
-        Resources::global_res->getObjResourceStr(obj, "icon-ref").c_str();
+        Resources::global_res->getObjResourceStr(current_obj, "icon-ref").c_str();
 
     vector<FWObject*> so = getSimplifiedSelection();
 
@@ -315,9 +332,46 @@
                          QPoint( pm.rect().width() / 2,
                                  pm.rect().height() / 2 ) );
 
-// lets try to always reset selection
-    setSelected(otvi,false);
-    resetSelection();
+/*
+ * This fragment returns selection in the tree back to the object that
+ * was selected before drag operation has started. This help in the
+ * following case:
+ *
+ *  - open a group for editing (group is selected in the tree)
+ *  - left-click on another object in the tree, start dragging it
+ *
+ * at this point selection in the tree returns to the group, so when
+ * user finishes d&d operation, the selection in the tree is consisten
+ * with object currently opened in the editor panel.
+ *
+ * There is a problem with this however. If user wants to put an
+ * object from a different library into the group, they have to switch
+ * to that library before doing d&d. When they switch, ObjectTree
+ * shown in the left panel becomes different from the tree in which
+ * the group is located. When d&d finishes, the ObjectTree object
+ * receives contentsMouseReleaseEvent event. Since it is not the right
+ * tree object, it can not properly restore selection and choses an
+ * object that was previously opened in that tree, which in turn
+ * changes the object opened in the editor panel. To make things
+ * worse, this event is only delivered to the tree object on Mac OS X.
+ *
+ * 
+ */
+    if (fwbdebug) qDebug("ObjectTreeView::dragObject()  this=%p visible=%d",
+                         this,visible);
+
+    FWObject *edit_obj = oe->getOpened();
+
+    if (oe->isVisible() && 
+        dragobj.size()==1 &&
+        edit_obj!=NULL &&
+        current_obj->getLibrary()==edit_obj->getLibrary() )
+    {
+        if (fwbdebug) qDebug("ObjectTreeView::dragObject() reset selection");
+        setSelected(otvi,false);
+        resetSelection();
+    }
+
 #if 0
     /*
      * need to reset selection if:
@@ -488,6 +542,7 @@
         qDebug("ObjectTreeView::contentsMousePressEvent");
 
     second_click = false;
+    process_mouse_release_event = true;
 
     if (fwbdebug)
     {
@@ -516,14 +571,38 @@
  * on a single click.
  *
  * uncomment the line that starts timer for mode #1.
+ *
+ *
+ * we use mouseReleaseEvent event to switch object opened in the
+ * editor panel (i.e. we open new object when mouse button is released
+ * rather than when it is pressed). This allows us to start drag
+ * without switching object in the editor. The problem is that
+ * mouseReleaseEvent is received in this widget after the d&d ends
+ * with a drop somewhere else, which triggers call to
+ * contentsMouseReleaseEvent which switches object in the editor. This
+ * is undesired when the editor shows a group and we try to drag and
+ * drop an object into that group. Flag process_mouse_release_event is
+ * used to suppress object switching when contentsMouseReleaseEvent is
+ * called after successfull drop.
+ *
  */
 void ObjectTreeView::contentsMouseReleaseEvent( QMouseEvent *e )
 {
     if (fwbdebug)
-        qDebug("ObjectTreeView::contentsMouseReleaseEvent 1");
+        qDebug("ObjectTreeView::contentsMouseReleaseEvent 1 this=%p  process_mouse_release_event=%d",
+               this,process_mouse_release_event);
 
     QListView::contentsMouseReleaseEvent(e);
 
+
+    if (!process_mouse_release_event)
+    {
+        // just do not switch object in the editor, otherwise
+        // process this event as usual
+        process_mouse_release_event = true;
+        return;
+    }
+
     if (fwbdebug)
         qDebug("ObjectTreeView::contentsMouseReleaseEvent 2 selectedObjects.size()=%d getCurrentObject()=%p current object %s",
                selectedObjects.size(),
diff -uNr fwbuilder-2.1.8/src/gui/ObjectTreeView.h fwbuilder-2.1.9/src/gui/ObjectTreeView.h
--- fwbuilder-2.1.8/src/gui/ObjectTreeView.h	2006-09-15 07:48:21.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/ObjectTreeView.h	2007-01-08 04:37:53.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: ObjectTreeView.h,v 1.19 2006/09/15 05:48:21 vkurland Exp $
+  $Id: ObjectTreeView.h,v 1.22 2007/01/08 03:37:53 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -52,6 +52,10 @@
     bool             Lockable;
     bool             Unlockable;
 
+    bool             visible;
+
+    bool             process_mouse_release_event;
+
     std::vector<libfwbuilder::FWObject*>          selectedObjects;
         
  protected:
@@ -92,7 +96,10 @@
     void editCurrentObject();
 
     void clearLastSelected();
-    
+
+    void becomingVisible() { visible=true; }
+    void becomingHidden()  { visible=false; }
+
 /* Under some circumstances, user may select several host or fw
  * objects so that their children objects are selected as well
  * (e.g. when shift-click is used). "Delete objects" or "group
@@ -103,6 +110,8 @@
  * actions.
  */
     std::vector<libfwbuilder::FWObject*> getSimplifiedSelection();
+
+    void ignoreNextMouseReleaseEvent() { process_mouse_release_event = false; }
     
  public slots:
 
diff -uNr fwbuilder-2.1.8/src/gui/pfAdvancedDialog.cpp fwbuilder-2.1.9/src/gui/pfAdvancedDialog.cpp
--- fwbuilder-2.1.8/src/gui/pfAdvancedDialog.cpp	2006-09-29 01:36:29.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/pfAdvancedDialog.cpp	2007-01-06 23:03:25.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: pfAdvancedDialog.cpp,v 1.20 2006/09/28 23:36:29 vkurland Exp $
+  $Id: pfAdvancedDialog.cpp,v 1.21 2007/01/06 22:03:25 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -260,7 +260,8 @@
 
 void pfAdvancedDialog::editProlog()
 {
-    SimpleTextEditor edt( prolog_script->text(),
+    SimpleTextEditor edt(this,
+                         prolog_script->text(),
                           true, tr( "Script Editor" ) );
     if ( edt.exec() == QDialog::Accepted )
         prolog_script->setText( edt.text() );
@@ -268,7 +269,8 @@
 
 void pfAdvancedDialog::editEpilog()
 {
-    SimpleTextEditor edt( epilog_script->text(),
+    SimpleTextEditor edt(this,
+                         epilog_script->text(),
                           true, tr( "Script Editor" ) );
     if ( edt.exec() == QDialog::Accepted )
         epilog_script->setText( edt.text() );
